// A simplified version of: https://www.shadertoy.com/view/4sfGRn
//SHADERTOY PORT FIX
#pragma header
vec2 uv = openfl_TextureCoordv.xy;
vec2 fragCoord = openfl_TextureCoordv*openfl_TextureSize;
vec2 Resolution = openfl_TextureSize;
uniform float Time;
#define PI 3.14159265
#define iChannel0 bitmap
#define texture flixel_texture2D
#define fragColor gl_FragColor
#define mainImage main
//SHADERTOY PORT FIX

uniform vec2 iResolution;

const float amount = 0.5;
const vec2 start_pos = vec2(0, 0); // -1.0 to 1.0 for x, y

vec3 deform( in vec2 p )
{
    vec2 uv;
    uv.x = sin( 0.0 + 1.0 ) + p.x;
    uv.y = sin( 0.0 + 1.0 ) + p.y;
    return texture( bitmap, uv * 0.5 ).xyz;
}

void main()
{
    vec2 fragCoord = openfl_TextureCoordv * iResolution;

    vec2 position = -1.0 + 2.0 * fragCoord.xy / iResolution.xy;
    vec2 current_step = position;
    
    vec2 direction = ( start_pos - position ) / amount; 
    
    vec3 total = vec3( 0.0 );
    for( int i = 0; i < int( amount ); i++ )
    {
        vec3 result = deform( current_step );
        result = smoothstep( 0.0, 1.0, result );
        total += result;
        current_step += direction;
    }
    
    total /= amount;
	gl_FragColor = vec4( total, 1.0 );
}